////
//// Internal signal constants
////

// ALU Math
`define ALU_ADD      5'b00000
`define ALU_ADDU     5'b10101
`define ALU_SUB      5'b00001
`define ALU_SUBU     5'b10100
`define ALU_OR       5'b00010
`define ALU_NOR	     5'b00011
`define ALU_SLL      5'b00100
`define ALU_SLLV     5'b00101
`define ALU_XOR      5'b00110
`define ALU_SRA      5'b00111
`define ALU_SRAV     5'b01000
`define ALU_SRL      5'b01001
`define ALU_SRLV     5'b01010
`define ALU_LUI      5'b01011
`define ALU_AND      5'b01100

// ALU Misc
`define ALU_OP1      5'b01001

// ALU Comparison
`define ALU_EQ       5'b01101
`define ALU_NE       5'b01110
`define ALU_LT       5'b01111
`define ALU_LE       5'b10000
`define ALU_GT       5'b10001
`define ALU_GE       5'b10010
`define ALU_LTU      5'b10011

// Memory controller
`define MC_DISABLED  2'b00
`define MC_BYTE      2'b01
`define MC_HALFWORD  2'b10
`define MC_WORD      2'b11

// Branch unit
`define BU_NEXT      2'b00
`define BU_CONDREL   2'b01
`define BU_ABSIMM    2'b10
`define BU_ABSALU    2'b11

// Register file
`define RDNUM_RT     2'b00
`define RDNUM_RD     2'b01
`define RDNUM_LR     2'b10

`define RDDATA_MC    2'b00
`define RDDATA_ALU   2'b01
`define RDDATA_PC    2'b10
`define RDDATA_MULT  2'b11

