`include "mips_defines.vh"
`include "internal_defines.vh"

module mips_core_id(/*AUTOARG*/
   // Outputs
   alu__opsel_2a, bubble_b_2a, ctrl_RI_2a, ctrl_Sys_2a,
   ctrl_alurtsel_2a, ctrl_immse_2a, ctrl_rddata_2a, inst_2a,
   inst_excpt_2a, mc__size_2a, mc__se_2a, mc__we_2a, mul__active_2a,
   mul__opcode_2a, pc_2a, reg__rd_num_2a, reg__rd_we_2a,
   reg__rs_data_2a, reg__rt_data_2a, stall_1a,
   // Inputs
   clk, halted, rst_b, bubble_b_1a, inst_1a, inst_excpt_1a,
   next_alu__out_2a, next_reg__rd_data_3a, pc_1a, reg__rd_data_1a,
   reg__rd_num_1a, reg__rd_we_1a, stall_2a, stall_3a, stall_4a
   );

   // Static interface
   output reg [4:0]  alu__opsel_2a;
   output reg 	     bubble_b_2a;
   output reg 	     ctrl_RI_2a;
   output reg 	     ctrl_Sys_2a;
   output reg 	     ctrl_alurtsel_2a;
   output reg 	     ctrl_immse_2a;
   output reg [1:0]  ctrl_rddata_2a;
   output reg [31:0] inst_2a;
   output reg 	     inst_excpt_2a;
   output reg [1:0]  mc__size_2a;
   output reg 	     mc__se_2a;
   output reg 	     mc__we_2a;
   output reg 	     mul__active_2a;
   output reg [2:0]  mul__opcode_2a;
   output reg [31:0] pc_2a;
   output reg [4:0]  reg__rd_num_2a;
   output reg 	     reg__rd_we_2a;
   output reg [31:0] reg__rs_data_2a;
   output reg [31:0] reg__rt_data_2a;
   output 	     stall_1a;
   input 	     clk, halted, rst_b;
   input 	     bubble_b_1a;
   input [31:0]      inst_1a;
   input 	     inst_excpt_1a;
   input [31:0]      next_alu__out_2a;
   input [31:0]      next_reg__rd_data_3a;
   input [31:0]      pc_1a;
   input [31:0]      reg__rd_data_1a;
   input [4:0] 	     reg__rd_num_1a;
   input 	     reg__rd_we_1a;
   input 	     stall_2a;
   input 	     stall_3a;
   input 	     stall_4a;
   
   // Internal signals
   reg [4:0] 	     next_reg__rd_num_1a;

   // Auto wire
   /*AUTOWIRE*/
   // Beginning of automatic wires (for undeclared instantiated-module outputs)
   wire			dcd_bczft;		// From Parser of mips_parse.v
   wire [19:0]		dcd_code;		// From Parser of mips_parse.v
   wire [31:0]		dcd_e_imm;		// From Parser of mips_parse.v
   wire [4:0]		dcd_funct1;		// From Parser of mips_parse.v
   wire [5:0]		dcd_funct2;		// From Parser of mips_parse.v
   wire [15:0]		dcd_imm;		// From Parser of mips_parse.v
   wire [15:0]		dcd_offset;		// From Parser of mips_parse.v
   wire [5:0]		dcd_op;			// From Parser of mips_parse.v
   wire [4:0]		dcd_rd;			// From Parser of mips_parse.v
   wire [4:0]		dcd_rs;			// From Parser of mips_parse.v
   wire [4:0]		dcd_rt;			// From Parser of mips_parse.v
   wire [31:0]		dcd_se_imm;		// From Parser of mips_parse.v
   wire [31:0]		dcd_se_mem_offset;	// From Parser of mips_parse.v
   wire [31:0]		dcd_se_offset;		// From Parser of mips_parse.v
   wire [4:0]		dcd_shamt;		// From Parser of mips_parse.v
   wire [25:0]		dcd_target;		// From Parser of mips_parse.v
   wire [4:0]		next_alu__opsel_1a;	// From Control of mips_control.v
   wire			next_ctrl_RI_1a;	// From Control of mips_control.v
   wire			next_ctrl_Sys_1a;	// From Control of mips_control.v
   wire			next_ctrl_alurtsel_1a;	// From Control of mips_control.v
   wire			next_ctrl_immse_1a;	// From Control of mips_control.v
   wire [1:0]		next_ctrl_rddata_1a;	// From Control of mips_control.v
   wire [1:0]		next_ctrl_rdnum_1a;	// From Control of mips_control.v
   wire			next_mc__se_1a;		// From Control of mips_control.v
   wire [1:0]		next_mc__size_1a;	// From Control of mips_control.v
   wire			next_mc__we_1a;		// From Control of mips_control.v
   wire			next_mul__active_1a;	// From Control of mips_control.v
   wire [2:0]		next_mul__opcode_1a;	// From Control of mips_control.v
   wire			next_reg__rd_we_1a;	// From Control of mips_control.v
   wire			next_reg__rs_re_1a;	// From Control of mips_control.v
   wire			next_reg__rt_re_1a;	// From Control of mips_control.v
   wire [31:0]		reg__rs_data;		// From regfile of mips_register_file.v
   wire [31:0]		reg__rt_data;		// From regfile of mips_register_file.v
   // End of automatics

   // Parse instruction
   mips_parse Parser(.inst(inst_1a),
		     /*AUTOINST*/
		     // Outputs
		     .dcd_se_imm	(dcd_se_imm[31:0]),
		     .dcd_se_offset	(dcd_se_offset[31:0]),
		     .dcd_e_imm		(dcd_e_imm[31:0]),
		     .dcd_se_mem_offset	(dcd_se_mem_offset[31:0]),
		     .dcd_op		(dcd_op[5:0]),
		     .dcd_funct2	(dcd_funct2[5:0]),
		     .dcd_rs		(dcd_rs[4:0]),
		     .dcd_funct1	(dcd_funct1[4:0]),
		     .dcd_rt		(dcd_rt[4:0]),
		     .dcd_rd		(dcd_rd[4:0]),
		     .dcd_shamt		(dcd_shamt[4:0]),
		     .dcd_offset	(dcd_offset[15:0]),
		     .dcd_imm		(dcd_imm[15:0]),
		     .dcd_target	(dcd_target[25:0]),
		     .dcd_code		(dcd_code[19:0]),
		     .dcd_bczft		(dcd_bczft));

   // Generate control signals
   /* mips_control AUTO_TEMPLATE (
        .\(dcd_.*\) (\1[]),
        .\(.*\) (next_\1_1a[]),
      );
    */
   mips_control Control(/*AUTOINST*/
			// Outputs
			.alu__opsel	(next_alu__opsel_1a[4:0]), // Templated
			.ctrl_RI	(next_ctrl_RI_1a),	 // Templated
			.ctrl_Sys	(next_ctrl_Sys_1a),	 // Templated
			.ctrl_alurtsel	(next_ctrl_alurtsel_1a), // Templated
			.ctrl_immse	(next_ctrl_immse_1a),	 // Templated
			.ctrl_rdnum	(next_ctrl_rdnum_1a[1:0]), // Templated
			.ctrl_rddata	(next_ctrl_rddata_1a[1:0]), // Templated
			.reg__rd_we	(next_reg__rd_we_1a),	 // Templated
			.reg__rs_re	(next_reg__rs_re_1a),	 // Templated
			.reg__rt_re	(next_reg__rt_re_1a),	 // Templated
			.mc__size	(next_mc__size_1a[1:0]), // Templated
			.mc__se		(next_mc__se_1a),	 // Templated
			.mc__we		(next_mc__we_1a),	 // Templated
			.mul__active	(next_mul__active_1a),	 // Templated
			.mul__opcode	(next_mul__opcode_1a[2:0]), // Templated
			// Inputs
			.dcd_op		(dcd_op[5:0]),		 // Templated
			.dcd_funct2	(dcd_funct2[5:0]),	 // Templated
			.dcd_rt		(dcd_rt[4:0]));		 // Templated

   // Destination register selection
   always @(*) begin
      next_reg__rd_num_1a = 5'bx;
      case (next_ctrl_rdnum_1a)
	`RDNUM_RT:
	  next_reg__rd_num_1a = dcd_rt;
	`RDNUM_RD:
	  next_reg__rd_num_1a = dcd_rd;
	`RDNUM_LR:
	  next_reg__rd_num_1a = 31;
      endcase // case (next_ctrl_rdnum_1a)
   end // always @ (*)

   // Register file
   mips_register_file regfile(.reg__rs_num(dcd_rs),
			      .reg__rt_num(dcd_rt),
			      .reg__rs_re(next_reg__rs_re_1a),
			      .reg__rt_re(next_reg__rt_re_1a),
			      .reg__rd_num(reg__rd_num_1a[4:0]),
			      .reg__rd_data(reg__rd_data_1a[31:0]),
			      .reg__rd_we(reg__rd_we_1a),
			      /*AUTOINST*/
			      // Outputs
			      .reg__rs_data	(reg__rs_data[31:0]),
			      .reg__rt_data	(reg__rt_data[31:0]),
			      .stall_1a		(stall_1a),
			      // Inputs
			      .clk		(clk),
			      .halted		(halted),
			      .rst_b		(rst_b),
			      .mc__size_2a	(mc__size_2a[1:0]),
			      .mc__we_2a	(mc__we_2a),
			      .mul__active_2a	(mul__active_2a),
			      .next_alu__out_2a	(next_alu__out_2a[31:0]),
			      .next_reg__rd_data_3a(next_reg__rd_data_3a[31:0]),
			      .next_reg__rd_num_1a(next_reg__rd_num_1a[4:0]),
			      .next_reg__rd_we_1a(next_reg__rd_we_1a),
			      .stall_2a		(stall_2a),
			      .stall_3a		(stall_3a),
			      .stall_4a		(stall_4a));

   // Registers
   always @(posedge clk or negedge rst_b) begin
      if (!rst_b) begin
	 /*AUTORESET*/
	 // Beginning of autoreset for uninitialized flops
	 alu__opsel_2a <= 5'h0;
	 bubble_b_2a <= 1'h0;
	 ctrl_RI_2a <= 1'h0;
	 ctrl_Sys_2a <= 1'h0;
	 ctrl_alurtsel_2a <= 1'h0;
	 ctrl_immse_2a <= 1'h0;
	 ctrl_rddata_2a <= 2'h0;
	 inst_2a <= 32'h0;
	 inst_excpt_2a <= 1'h0;
	 mc__se_2a <= 1'h0;
	 mc__size_2a <= 2'h0;
	 mc__we_2a <= 1'h0;
	 mul__active_2a <= 1'h0;
	 mul__opcode_2a <= 3'h0;
	 pc_2a <= 32'h0;
	 reg__rd_num_2a <= 5'h0;
	 reg__rd_we_2a <= 1'h0;
	 reg__rs_data_2a <= 32'h0;
	 reg__rt_data_2a <= 32'h0;
	 // End of automatics
      end else begin
	 if (!stall_2a && !stall_3a && !stall_4a) begin
	    // Used
	    alu__opsel_2a <= next_alu__opsel_1a;
	    ctrl_RI_2a <= next_ctrl_RI_1a;
	    ctrl_Sys_2a <= next_ctrl_Sys_1a;
	    ctrl_alurtsel_2a <= next_ctrl_alurtsel_1a;
	    ctrl_immse_2a <= next_ctrl_immse_1a;
	    ctrl_rddata_2a <= next_ctrl_rddata_1a;
	    mc__size_2a <= next_mc__size_1a;
	    mc__se_2a <= next_mc__se_1a;
	    mc__we_2a <= next_mc__we_1a;
	    mul__active_2a <= next_mul__active_1a;
	    mul__opcode_2a <= next_mul__opcode_1a;
	    reg__rd_num_2a <= next_reg__rd_num_1a;
	    reg__rd_we_2a <= next_reg__rd_we_1a;
	    reg__rs_data_2a <= reg__rs_data;
	    reg__rt_data_2a <= reg__rt_data;
    
	    // Pass through
	    bubble_b_2a <= bubble_b_1a;
	    inst_2a <= inst_1a;
	    inst_excpt_2a <= inst_excpt_1a;
	    pc_2a <= pc_1a;

	    // We stall
	    if (stall_1a) begin
	       bubble_b_2a <= 1'b0;
               reg__rd_we_2a <= 1'b0;
            end

	    // We are a bubble
	    if (!bubble_b_1a) begin
	       ctrl_RI_2a <= 1'b0;
	       ctrl_Sys_2a <= 1'b0;
	       inst_excpt_2a <= 1'b0;
	       mc__we_2a <= 1'b0;
	       reg__rd_we_2a <= 1'b0;
	    end
	 end
      end
   end
endmodule // mips_core_id

