`include "mips_defines.vh"
`include "internal_defines.vh"

module mips_core_if(/*AUTOARG*/
   // Outputs
   inst_addr, bubble_b_1a, inst_1a, pc_1a, inst_excpt_1a,
   // Inputs
   clk, rst_b, inst_excpt, inst_0a, stall_1a, stall_2a, stall_3a,
   stall_4a
   );

   parameter text_start = 32'h00400000; /* Initial value of $pc */

   // Static interface
   output [29:0]     inst_addr;
   output reg 	     bubble_b_1a;
   output reg [31:0] inst_1a;
   output reg [31:0] pc_1a;
   output reg 	     inst_excpt_1a;
   input 	     clk, rst_b;
   input 	     inst_excpt;
   input [31:0]      inst_0a;
   input 	     stall_1a;
   input 	     stall_2a;
   input 	     stall_3a;
   input 	     stall_4a;
   
   // Disabled for Lab 2
   // input [31:0]  alu__out_0a;
   // input [1:0] 	 bu__select_0a;

   // Internal signals
   wire [31:0] 	 next_pc_0a;

   // Auto-wire
   /*AUTOWIRE*/

   // Instruction parse
   // Disabled for Lab 2
   // mips_parse Parser(.inst(inst_0a),
   // 		        /*AUTOINST*/);

   // Branch Management
   // Disabled for Lab 2
   // branch_unit BranchUnit(.bu__absimm(dcd_target),
   //			  .bu__absalu(alu__out_0a),
   //			  .bu__condition(alu__out_0a[0]),
   // 			  .bu__offset(dcd_se_offset),
   // 			  .bu__select(bu__select_0a),
   // 			  .pc(next_pc_0a),
   // 			  /*AUTOINST*/);
   assign next_pc_0a = pc_1a + 4;

   // Compute instruction address
   assign inst_addr = pc_1a[31:2];

   // Registers
   always @(posedge clk or negedge rst_b) begin
      if (!rst_b) begin
	 pc_1a <= text_start;
	 /*AUTORESET*/
	 // Beginning of autoreset for uninitialized flops
	 bubble_b_1a <= 1'h0;
	 inst_1a <= 32'h0;
	 inst_excpt_1a <= 1'h0;
	 // End of automatics
      end else begin
	 if (!stall_1a && !stall_2a && !stall_3a && !stall_4a) begin
	    // Used
	    bubble_b_1a <= 1'b1;
	    inst_excpt_1a <= inst_excpt;
	    pc_1a <= next_pc_0a;

	    // Pass through
	    inst_1a <= inst_0a;
	 end
      end
   end
endmodule // mips_core_if
