module mips_core_wb(/*AUTOARG*/
   // Outputs
   reg__rd_data_1a, reg__rd_num_1a, reg__rd_we_1a, stall_4a,
   exception_halt, syscall_halt,
   // Inputs
   clk, rst_b, bubble_b_4a, ctrl_RI_4a, ctrl_Sys_4a, inst_excpt_4a,
   mc__AdEL_data_4a, mc__AdES_4a, mc__DBE_4a, oflow_halt_4a, pc_4a,
   reg__rd_data_4a, reg__rd_num_4a, reg__rd_we_4a
   );

   // Static interface
   output [31:0]     reg__rd_data_1a;
   output [4:0]      reg__rd_num_1a;
   output 	     reg__rd_we_1a;
   output 	     stall_4a;
   output 	     exception_halt;
   output 	     syscall_halt;
   input 	     clk, rst_b;
   input 	     bubble_b_4a;
   input 	     ctrl_RI_4a;
   input 	     ctrl_Sys_4a;
   input 	     inst_excpt_4a;
   input 	     mc__AdEL_data_4a;
   input 	     mc__AdES_4a;
   input 	     mc__DBE_4a;
   input 	     oflow_halt_4a;
   input [31:0]      pc_4a;
   input [31:0]      reg__rd_data_4a;
   input [4:0] 	     reg__rd_num_4a;
   input 	     reg__rd_we_4a;

   // Auto wire
   /*AUTOWIRE*/
   
   // Internal signals
   wire 		AdEL_inst;

   // Syscall
   syscall_unit SU(.Sys(ctrl_Sys_4a),
		   .r_v0(32'h0a), // FIXME:
		   .pc(pc_4a),
		   /*AUTOINST*/
		   // Outputs
		   .syscall_halt	(syscall_halt),
		   // Inputs
		   .rst_b		(rst_b),
		   .clk			(clk));

   // Exceptions
   assign AdEL_inst = pc_4a[1:0] != 2'b0;

   // All exceptions halt for lab 2
   assign exception_halt = AdEL_inst |
			   mc__AdEL_data_4a |
			   mc__AdES_4a |
			   mc__DBE_4a |
			   inst_excpt_4a |
			   oflow_halt_4a |
			   ctrl_RI_4a;

   // Disabled for Lab 2
/* -----\/----- EXCLUDED -----\/-----
   exception_unit EU(.pc(pc_4a),
		     .AdEL_data(mc__AdEL_data_4a),
		     .AdES(mc__AdES_4a),
		     .BP(1'b0),
		     .CpU(1'b0),
		     .DBE(mc__DBE_4a),
		     .IBE(inst_excpt_4a),
		     .Ov(oflow_halt_4a),
		     .RI(ctrl_RI_4a),
		     /-*AUTOINST*-/
		     // Outputs
		     .exception_halt	(exception_halt),
		     .load_ex_regs	(load_ex_regs),
		     .load_bva		(load_bva),
		     .cause		(cause[4:0]),
		     .load_bva_sel	(load_bva_sel),
		     // Inputs
		     .AdEL_inst		(AdEL_inst),
		     .clk		(clk),
		     .rst_b		(rst_b));
 -----/\----- EXCLUDED -----/\----- */
   
   // Not registers
   assign reg__rd_data_1a = reg__rd_data_4a;
   assign reg__rd_num_1a = reg__rd_num_4a;
   assign reg__rd_we_1a = (bubble_b_4a && !exception_halt) ? reg__rd_we_4a : 1'b0;
   assign stall_4a = 1'b0;
endmodule

