module mips_debug(/*AUTOARG*/
   // Inputs
   clk, rst_b, halted, bubble_b_1a, bubble_b_2a, bubble_b_3a,
   bubble_b_4a, stall_1a, stall_2a, stall_3a, stall_4a
   );

   // Static interface
   input 	clk, rst_b, halted;
   input 	bubble_b_1a, bubble_b_2a, bubble_b_3a, bubble_b_4a;
   input        stall_1a, stall_2a, stall_3a, stall_4a;

   // Debug spam
   always @(posedge clk) begin
     if (rst_b) begin
	$display("=== Simulation Cycle %d ===", $time);
	//$display("[pc=%x, inst=%x] [op=%x, rs=%d, rt=%d, rd=%d, imm=%x, f2=%x] [reset=%d, halted=%d]",
        //         pc, inst, dcd_op, dcd_rs, dcd_rt, dcd_rd, dcd_imm, dcd_funct2, ~rst_b, halted);
	$display(" IF: ");
	$display(" ID: %s%s", bubble_b_1a ? "" : "bubble ", stall_1a ? "stall " : "");
	$display(" EX: %s%s", bubble_b_2a ? "" : "bubble ", stall_2a ? "stall " : "");
	$display("MEM: %s%s", bubble_b_3a ? "" : "bubble ", stall_3a ? "stall " : "");
	$display(" WB: %s%s", bubble_b_4a ? "" : "bubble ", stall_4a ? "stall " : "");
     end
   end
endmodule // mips_debug

// Local variables:
// verilog-auto-output-ignore-regexp:"^dcd_"
// End:
